"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isEmptyObject = exports.smartLog = exports.currentRouter = exports.objectToArray = exports.removeArrayItemByIndex = exports.removeArrayItemByValue = exports.arrayToObject = exports.arrayEquals = exports.reverseString = exports.delay = exports.fetchRequest = exports.navigateHandler = exports.generateArray = exports.upperFirst = void 0;
const axios_1 = __importDefault(require("axios"));
const upperFirst = (str) => {
    return str.charAt(0).toUpperCase() + str.slice(1);
};
exports.upperFirst = upperFirst;
const generateArray = (n) => {
    return Array.from({ length: n }, (_, i) => i + 1);
};
exports.generateArray = generateArray;
const navigateHandler = (targetUrl, inNewWindow) => {
    if (inNewWindow) {
        open(targetUrl, "_blank");
    }
    else {
        location.href = targetUrl;
    }
};
exports.navigateHandler = navigateHandler;
const fetchRequest = (url) => __awaiter(void 0, void 0, void 0, function* () {
    const response = yield axios_1.default.get(url);
    const data = yield response.data;
    return data;
});
exports.fetchRequest = fetchRequest;
const delay = (milliseconds) => {
    return new Promise(resolve => setTimeout(resolve, milliseconds));
};
exports.delay = delay;
const reverseString = (str) => {
    return str.split("").reverse().join("");
};
exports.reverseString = reverseString;
const arrayEquals = (a, b) => {
    return (Array.isArray(a) &&
        Array.isArray(b) &&
        a.length === b.length &&
        a.every((val, index) => val === b[index]));
};
exports.arrayEquals = arrayEquals;
const arrayToObject = (array, key) => {
    return array.reduce((obj, item) => {
        obj[item[key]] = item;
        return obj;
    }, {});
};
exports.arrayToObject = arrayToObject;
const removeArrayItemByValue = (array, value) => {
    const index = array.indexOf(value);
    if (index > -1) {
        array.splice(index, 1);
    }
    return array;
};
exports.removeArrayItemByValue = removeArrayItemByValue;
const removeArrayItemByIndex = (array, index) => {
    if (index > -1) {
        array.splice(index, 1);
    }
    return array;
};
exports.removeArrayItemByIndex = removeArrayItemByIndex;
const objectToArray = (obj) => {
    return Object.keys(obj).map(key => obj[key]);
};
exports.objectToArray = objectToArray;
const currentRouter = () => {
    const url = window.location.href;
    const pathname = window.location.pathname;
    const hash = window.location.hash;
    const query = window.location.search;
    const protocol = window.location.protocol;
    const host = window.location.host;
    const hostname = window.location.hostname;
    const port = window.location.port;
    const urlObject = {
        url,
        pathname,
        hash,
        query,
        protocol,
        host,
        hostname,
        port,
    };
    return urlObject;
};
exports.currentRouter = currentRouter;
const smartLog = (value, currentFunction, label) => {
    return console.log(`%c[${currentFunction.name}] -`, "color: red", label ? `${label}:` : "DEBUG:", value);
};
exports.smartLog = smartLog;
function isEmptyObject(obj) {
    return JSON.stringify(obj) === "{}";
}
exports.isEmptyObject = isEmptyObject;
